diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/laser.cpp alien-rc4/src//game/server/entities/laser.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/laser.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/laser.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -3,10 +3,12 @@
 #include <game/generated/protocol.h>
 #include <game/server/gamecontext.h>
 #include "laser.h"
+#include <game/server/gamemodes/mod.h>
 
-CLaser::CLaser(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner)
+CLaser::CLaser(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner, int SubType)
 : CEntity(pGameWorld, CGameWorld::ENTTYPE_LASER)
 {
+	m_SubType = SubType;
 	m_Pos = Pos;
 	m_Owner = Owner;
 	m_Energy = StartEnergy;
@@ -18,19 +20,76 @@ CLaser::CLaser(CGameWorld *pGameWorld, v
 }
 
 
+// Mutator 
+const char *CLaser::m_SubDescription[] =
+{
+	"* Laser *", "* Riddle-Laser *", "* Tele-Laserinator *", "* Healing-Laser *"
+};
+
 bool CLaser::HitCharacter(vec2 From, vec2 To)
 {
 	vec2 At;
-	CCharacter *OwnerChar = GameServer()->GetPlayerChar(m_Owner);
-	CCharacter *Hit = GameServer()->m_World.IntersectCharacter(m_Pos, To, 0.f, At, OwnerChar);
-	if(!Hit)
+	CCharacter *pOwnerChar = GameServer()->GetPlayerChar(m_Owner);
+	CCharacter *pHit = GameServer()->m_World.IntersectCharacter(m_Pos, To, 0.f, At, pOwnerChar);
+	if(!pHit)
 		return false;
 
-	m_From = From;
-	m_Pos = At;
-	m_Energy = -1;
-	Hit->TakeDamage(vec2(0.f, 0.f), GameServer()->Tuning()->m_LaserDamage, m_Owner, WEAPON_RIFLE);
-	return true;
+	// Tele-Laser
+	if(m_SubType == LASER_SUBTYPE_TELE && pOwnerChar)
+	{
+		if(pHit->IsAlive() && pOwnerChar->IsAlive())
+		{
+			vec2 TeleFrom = pOwnerChar->m_Pos;
+			vec2 TeleTo = pHit->m_Pos;
+			pOwnerChar->SetPos(TeleTo);
+			pHit->SetPos(TeleFrom);
+		}
+		else
+			return false;
+	}
+
+	// Healing-Laser	
+	if(m_SubType == LASER_SUBTYPE_HEALING)
+	{
+		if(pHit->GetPlayer()->m_MutatorTeam <= TEAM_MUTANT)
+		{
+			pHit->ReMutate();
+			if(pOwnerChar && pHit)
+			{
+				CPlayer *pKiller = pOwnerChar->GetPlayer();
+				CPlayer *pVictim = pHit->GetPlayer();
+				if(pKiller && pVictim)
+				{
+					int ModeSpecial = GameServer()->m_pController->OnCharacterDeath(pHit, GameServer()->m_apPlayers[pKiller->GetCID()], WEAPON_RIFLE);
+					CNetMsg_Sv_KillMsg Msg;
+					Msg.m_Killer = pKiller->GetCID();
+					Msg.m_Victim = pVictim->GetCID();
+					Msg.m_Weapon = WEAPON_RIFLE;
+					Msg.m_ModeSpecial = ModeSpecial;
+					Server()->SendPackMsg(&Msg, MSGFLAG_VITAL, -1);
+					pKiller->m_Score++;
+				}
+			}
+		}
+		else
+			pHit->IncreaseHealth(10);
+	}
+	else
+		pHit->TakeDamage(vec2(0.f, 0.f), GameServer()->Tuning()->m_LaserDamage, m_Owner, WEAPON_RIFLE);
+
+	// Riddle-Laser
+	if(m_SubType == LASER_SUBTYPE_RIDDLE)
+	{
+		GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+		return false;
+	}
+	else
+	{
+		m_From = From;
+		m_Pos = At;
+		m_Energy = -1;
+		return true;
+	}
 }
 
 void CLaser::DoBounce()
@@ -91,6 +150,11 @@ void CLaser::Tick()
 		DoBounce();
 }
 
+void CLaser::TickPaused()
+{
+	++m_EvalTick;
+}
+
 void CLaser::Snap(int SnappingClient)
 {
 	if(NetworkClipped(SnappingClient))
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/laser.h alien-rc4/src//game/server/entities/laser.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/laser.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/laser.h	2012-06-14 23:57:39.000000000 +0200
@@ -5,14 +5,28 @@
 
 #include <game/server/entity.h>
 
+
+// Mutator
+enum
+{
+        LASER_SUBTYPE_NORMAL=0,
+        LASER_SUBTYPE_RIDDLE,
+        LASER_SUBTYPE_TELE,
+        LASER_SUBTYPE_HEALING,
+	LASER_MAX_SUBTYPE,
+};
+
+
 class CLaser : public CEntity
 {
 public:
-	CLaser(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner);
+	CLaser(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner, int SubType);
 
 	virtual void Reset();
 	virtual void Tick();
+	virtual void TickPaused();
 	virtual void Snap(int SnappingClient);
+	static const char * m_SubDescription[];
 
 protected:
 	bool HitCharacter(vec2 From, vec2 To);
@@ -25,6 +39,7 @@ private:
 	int m_Bounces;
 	int m_EvalTick;
 	int m_Owner;
+	int m_SubType;
 };
 
 #endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/laserturret.cpp alien-rc4/src//game/server/entities/laserturret.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/laserturret.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/laserturret.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,78 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#include <game/generated/protocol.h>
+#include <game/server/gamecontext.h>
+#include "laser.h"
+#include "laserturret.h"
+#include <game/server/gamemodes/mod.h>
+#include <engine/shared/config.h>
+
+CLaserTurret::CLaserTurret(CGameWorld *pGameWorld, vec2 Pos)
+: CEntity(pGameWorld, CGameWorld::ENTTYPE_LASER)
+{
+	m_Pos = Pos;
+	m_FireDelayTick = Server()->Tick();
+	GameWorld()->InsertEntity(this);
+}
+
+bool CLaserTurret::AimVictim()
+{
+	float ClosestRange = 9999; // just dummy maxval out of range to get some start-value for searching nearest
+	CCharacter *pClosest = 0;
+	vec2 CheckVel;
+
+	CCharacter *p = (CCharacter *)GameServer()->m_World.FindFirst(CGameWorld::ENTTYPE_CHARACTER);
+	for(; p; p = (CCharacter *)p->TypeNext())
+	{
+		// just aim what you see
+		if(!p || !p->IsAlive() || GameServer()->Collision()->IntersectLine(m_Pos, p->m_Pos, 0x0, 0x0))
+			continue;	
+		
+		// just aim if victim moved fast enough (slow movement = no detection)
+		if(length(p->GetVel()) < g_Config.m_SvMaxTurretAimVel)
+			continue;	
+
+		// just fire on mutants? 
+		if(g_Config.m_SvTurretAimNoHumans && p->GetPlayer()->m_MutatorTeam >= TEAM_HUMAN)
+			continue;
+		
+		float Len = distance(m_Pos, p->m_Pos);
+		if(Len < p->m_ProximityRadius+g_Config.m_SvTurretRange)
+		{
+			if(Len < ClosestRange)
+			{
+				ClosestRange = Len;
+				pClosest = p;
+			}
+		}
+	}
+	
+	if(pClosest)
+	{
+		GameServer()->CreateSound(m_Pos, SOUND_RIFLE_FIRE);
+		new CLaser(GameWorld(), m_Pos, normalize(pClosest->m_Pos - m_Pos), GameServer()->Tuning()->m_LaserReach, -1, LASER_SUBTYPE_NORMAL);
+		return true;
+	}
+	else
+		return false;
+}
+
+void CLaserTurret::Reset()
+{
+	return;
+}
+
+void CLaserTurret::Tick()
+{
+	if(Server()->Tick() - m_FireDelayTick > 0)
+	{
+		if(GameServer()->m_pController->MutPowerSupply() == 1 && AimVictim())
+			m_FireDelayTick = Server()->Tick() + 600 * Server()->TickSpeed() / 1000;
+		else
+			m_FireDelayTick = Server()->Tick() + 10 * Server()->TickSpeed() / 1000;
+	}
+}
+
+void CLaserTurret::Snap(int SnappingClient)
+{
+	return;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/laserturret.h alien-rc4/src//game/server/entities/laserturret.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/laserturret.h	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/laserturret.h	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,25 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#ifndef GAME_SERVER_ENTITIES_LASERTURRET_H
+#define GAME_SERVER_ENTITIES_LASERTURRET_H
+
+#include <game/server/entity.h>
+
+
+class CLaserTurret : public CEntity
+{
+public:
+	CLaserTurret(CGameWorld *pGameWorld, vec2 Pos);
+
+	virtual void Reset();
+	virtual void Tick();
+	virtual void Snap(int SnappingClient);
+	static const char * m_SubDescription[];
+
+protected:
+	bool AimVictim();
+
+private:
+	int m_FireDelayTick;
+};
+
+#endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/laserwall.cpp alien-rc4/src//game/server/entities/laserwall.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/laserwall.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/laserwall.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,155 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#include <game/generated/protocol.h>
+#include <game/server/gamecontext.h>
+#include "laserwall.h"
+#include <game/server/gamemodes/mod.h>
+#include <engine/shared/config.h>
+
+CLaserWall::CLaserWall(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner)
+: CEntity(pGameWorld, CGameWorld::ENTTYPE_LASER)
+{
+	m_Pos = Pos;
+	m_Owner = Owner;
+	m_Energy = StartEnergy;
+	m_Dir = Direction;
+	m_From = Pos; 
+	m_FromFinal = m_Pos + m_Dir * m_Energy;
+	m_EvalTick = 0;
+
+	CCharacter *pOwnerChar = GameServer()->GetPlayerChar(m_Owner);
+	if(!pOwnerChar)
+		return;
+	else if(pOwnerChar->GetPlayer()->m_ScienceExplored&SCIENCE_BATTERY)
+		m_ConsumePowerTick = Server()->Tick() + g_Config.m_SvLaserWallDelay * Server()->TickSpeed() + g_Config.m_SvSuperBattery * Server()->TickSpeed() / 1000;
+	else
+		m_ConsumePowerTick = Server()->Tick() + g_Config.m_SvLaserWallDelay * Server()->TickSpeed() + g_Config.m_SvNormalBattery * Server()->TickSpeed() / 1000;
+	
+	m_FirstTick = Server()->Tick();	
+	m_InitDelayTick = Server()->Tick() + Server()->TickSpeed();	
+	m_InitDelayCounter = 0;
+	GameWorld()->InsertEntity(this);
+}
+
+
+bool CLaserWall::HitCharacter(vec2 From, vec2 To)
+{
+	vec2 At;
+	CCharacter *pOwnerChar = GameServer()->GetPlayerChar(m_Owner);
+
+	// Check if owner is still alive and no Mutant
+	if(!pOwnerChar)
+	{
+		GameServer()->m_World.DestroyEntity(this);
+		return false;
+	} 
+	else if(pOwnerChar->GetPlayer()->m_MutatorTeam <= TEAM_MUTANT)
+	{
+		pOwnerChar->DestroyLaserWall();
+		return false;
+	}
+	
+	// Check absolute timelimit if required	
+	if((g_Config.m_SvLWLimitNonAlMap && !GameServer()->m_pController->FoundHammerPickups()) || g_Config.m_SvLWLimit)
+	{
+		if(pOwnerChar->GetPlayer()->m_ScienceExplored&SCIENCE_BATTERY)
+		{
+			if(Server()->Tick() - (m_FirstTick + g_Config.m_SvSuperBattery * Server()->TickSpeed() / 100) > 0)
+			{	
+				GameServer()->CreateSound(m_Pos, SOUND_GRENADE_EXPLODE);
+				GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+				GameServer()->CreateExplosion(m_Pos, m_Owner, WEAPON_RIFLE, false);
+				pOwnerChar->DestroyLaserWall();
+				return false;
+			}
+		}
+		else
+		{
+			if(Server()->Tick() - (m_FirstTick + g_Config.m_SvNormalBattery * Server()->TickSpeed() / 100) > 0)
+			{
+				GameServer()->CreateSound(m_Pos, SOUND_GRENADE_EXPLODE);
+				GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+				GameServer()->CreateExplosion(m_Pos, m_Owner, WEAPON_RIFLE, false);
+				pOwnerChar->DestroyLaserWall();
+				return false;
+			}
+		}
+	}
+	
+	// Consume Power 
+	if(m_InitDelayCounter == g_Config.m_SvLaserWallDelay && Server()->Tick() - m_ConsumePowerTick > 0)
+	{
+		if(!pOwnerChar->DecreaseArmor(1))
+		{
+			pOwnerChar->DestroyLaserWall();
+			return false;
+		}
+		else
+		{
+			if(pOwnerChar->GetPlayer()->m_ScienceExplored&SCIENCE_BATTERY)
+				m_ConsumePowerTick = Server()->Tick() + g_Config.m_SvSuperBattery * Server()->TickSpeed() / 1000;
+			else
+				m_ConsumePowerTick = Server()->Tick() + g_Config.m_SvNormalBattery * Server()->TickSpeed() / 1000;
+		}
+	}	
+		
+	// Check Collision
+	CCharacter *pHit = GameServer()->m_World.IntersectCharacter(m_Pos, To, 0.f, At, pOwnerChar);
+	if(!pHit)
+		return false;
+
+	pHit->TakeDamage(vec2(0.f, 0.f), GameServer()->Tuning()->m_LaserDamage, m_Owner, WEAPON_RIFLE);
+	return true;
+}
+
+void CLaserWall::Reset()
+{
+	GameServer()->m_World.DestroyEntity(this);
+}
+
+void CLaserWall::Tick()
+{
+	if(Server()->Tick() % (170 * Server()->TickSpeed() / 1000) == 0)
+		m_EvalTick = Server()->Tick();
+	if(m_InitDelayCounter < g_Config.m_SvLaserWallDelay && Server()->Tick() - m_InitDelayTick > 0)
+	{
+		m_InitDelayCounter++;
+		if(m_InitDelayCounter == g_Config.m_SvLaserWallDelay)
+		{
+			GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+			// Test if Laser hit wall (if yes just cut no bounce).
+			vec2 TestFrom = m_FromFinal;
+			if(GameServer()->Collision()->IntersectLine(m_Pos, TestFrom, 0x0, &TestFrom))
+			{
+				m_Energy = distance(TestFrom, m_Pos)*1.1f;
+				m_From = m_Pos + m_Dir * m_Energy;
+			}
+			else	
+				m_From = m_FromFinal;
+			
+			HitCharacter(m_Pos, m_From);	
+		}
+		else
+		{
+			GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+			m_InitDelayTick = Server()->Tick() + Server()->TickSpeed();
+		}
+	}
+	else
+		HitCharacter(m_Pos, m_From);	
+}
+
+void CLaserWall::Snap(int SnappingClient)
+{
+	if(NetworkClipped(SnappingClient))
+		return;
+
+	CNetObj_Laser *pObj = static_cast<CNetObj_Laser *>(Server()->SnapNewItem(NETOBJTYPE_LASER, m_ID, sizeof(CNetObj_Laser)));
+	if(!pObj)
+		return;
+
+	pObj->m_X = (int)m_Pos.x;
+	pObj->m_Y = (int)m_Pos.y;
+	pObj->m_FromX = (int)m_From.x;
+	pObj->m_FromY = (int)m_From.y;
+	pObj->m_StartTick = m_EvalTick;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/laserwall.h alien-rc4/src//game/server/entities/laserwall.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/laserwall.h	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/laserwall.h	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,33 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#ifndef GAME_SERVER_ENTITIES_LASERWALL_H
+#define GAME_SERVER_ENTITIES_LASERWALL_H
+
+#include <game/server/entity.h>
+
+class CLaserWall : public CEntity
+{
+public:
+	CLaserWall(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner);
+
+	virtual void Reset();
+	virtual void Tick();
+	virtual void Snap(int SnappingClient);
+
+protected:
+	bool HitCharacter(vec2 From, vec2 To);
+
+private:
+	vec2 m_From;
+	vec2 m_FromFinal;
+	vec2 m_Dir;
+	float m_Energy;
+	int m_EvalTick;
+	int m_FirstTick;
+	int m_Owner;
+	int m_ConsumePowerTick;
+	int m_InitDelayTick;
+        int m_InitDelayCounter;
+
+};
+
+#endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/pickup.cpp alien-rc4/src//game/server/entities/pickup.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/pickup.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/pickup.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -3,6 +3,8 @@
 #include <game/generated/protocol.h>
 #include <game/server/gamecontext.h>
 #include "pickup.h"
+#include <game/server/gamemodes/mod.h>
+#include <engine/shared/config.h>
 
 CPickup::CPickup(CGameWorld *pGameWorld, int Type, int SubType)
 : CEntity(pGameWorld, CGameWorld::ENTTYPE_PICKUP)
@@ -44,6 +46,10 @@ void CPickup::Tick()
 	CCharacter *pChr = GameServer()->m_World.ClosestCharacter(m_Pos, 20.0f, 0);
 	if(pChr && pChr->IsAlive())
 	{
+		pChr->SetOnScience(0);
+		if(pChr->GetPlayer()->m_MutatorTeam <= TEAM_MUTANT)
+			return;
+
 		// player picked us up, is someone was hooking us, let them go
 		int RespawnTime = -1;
 		switch (m_Type)
@@ -67,7 +73,39 @@ void CPickup::Tick()
 			case POWERUP_WEAPON:
 				if(m_Subtype >= 0 && m_Subtype < NUM_WEAPONS)
 				{
-					if(pChr->GiveWeapon(m_Subtype, 10))
+					if(m_Subtype == WEAPON_HAMMER)					
+					{
+						pChr->SetOnScience(1);
+						if(pChr->GetActiveWeapon() == WEAPON_HAMMER && pChr->IsFiring())
+						{
+							if(GameServer()->m_pController->MutPowerSupply() && g_Config.m_SvScienceSuccessCount > 0)
+							{
+								if(pChr->DecreaseArmor(1))
+								{
+									pChr->SetShowInfoTick(Server()->Tick() + 2 * Server()->TickSpeed());
+									m_SpawnTick = Server()->Tick() + g_Config.m_SvScienceSpawn * Server()->TickSpeed() / 1000;	
+									GameServer()->CreateSound(m_Pos, SOUND_PICKUP_ARMOR);
+									pChr->GetPlayer()->m_ScienceCount++;
+									if(pChr->GetPlayer()->m_ScienceCount >= g_Config.m_SvScienceSuccessCount)
+									pChr->ScienceResearch(0);
+								}
+								else if(Server()->Tick() - pChr->GetShowInfoTick() > 0)
+								{
+									pChr->SetShowInfoTick(Server()->Tick() + 2 * Server()->TickSpeed());
+									GameServer()->SendChatTarget(pChr->GetPlayer()->GetCID(),"Shields required for research!");
+								}
+							}
+							else if(Server()->Tick() - pChr->GetShowInfoTick() > 0)
+							{
+								pChr->SetShowInfoTick(Server()->Tick() + 2 * Server()->TickSpeed());
+								if(g_Config.m_SvScienceSuccessCount > 0)
+									GameServer()->SendChatTarget(pChr->GetPlayer()->GetCID(),"Research failed! Generator is down!");
+								else
+									GameServer()->SendChatTarget(pChr->GetPlayer()->GetCID(),"Research failed! Station is disabled!");
+							}
+						}
+					}
+					else if(pChr->GiveWeapon(m_Subtype, 10))
 					{
 						RespawnTime = g_pData->m_aPickups[m_Type].m_Respawntime;
 
@@ -117,6 +155,12 @@ void CPickup::Tick()
 	}
 }
 
+void CPickup::TickPaused()
+{
+	if(m_SpawnTick != -1)
+		++m_SpawnTick;
+}
+
 void CPickup::Snap(int SnappingClient)
 {
 	if(m_SpawnTick != -1 || NetworkClipped(SnappingClient))
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/pickup.h alien-rc4/src//game/server/entities/pickup.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/pickup.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/pickup.h	2012-06-14 23:57:39.000000000 +0200
@@ -14,6 +14,7 @@ public:
 
 	virtual void Reset();
 	virtual void Tick();
+	virtual void TickPaused();
 	virtual void Snap(int SnappingClient);
 
 private:
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/projectile.cpp alien-rc4/src//game/server/entities/projectile.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/projectile.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/projectile.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -5,7 +5,9 @@
 #include "projectile.h"
 
 CProjectile::CProjectile(CGameWorld *pGameWorld, int Type, int Owner, vec2 Pos, vec2 Dir, int Span,
-		int Damage, bool Explosive, float Force, int SoundImpact, int Weapon)
+		int Damage, bool Explosive, float Force, int SoundImpact, int Weapon, 
+		int Clusters, int ClusterType, int ClusterLifeSpan, int ClusterDamage, bool ClusterExplosive, float ClusterForce,
+                int ClusterSoundImpact)
 : CEntity(pGameWorld, CGameWorld::ENTTYPE_PROJECTILE)
 {
 	m_Type = Type;
@@ -20,6 +22,14 @@ CProjectile::CProjectile(CGameWorld *pGa
 	m_StartTick = Server()->Tick();
 	m_Explosive = Explosive;
 
+	m_Clusters = Clusters;
+	m_ClusterType = ClusterType;
+	m_ClusterLifeSpan = ClusterLifeSpan;
+	m_ClusterDamage = ClusterDamage;
+	m_ClusterExplosive = ClusterExplosive;
+	m_ClusterForce = ClusterForce;
+	m_ClusterSoundImpact = ClusterSoundImpact;
+
 	GameWorld()->InsertEntity(this);
 }
 
@@ -73,15 +83,67 @@ void CProjectile::Tick()
 			GameServer()->CreateSound(CurPos, m_SoundImpact);
 
 		if(m_Explosive)
-			GameServer()->CreateExplosion(CurPos, m_Owner, m_Weapon, false);
+		{
+			// Mutator
+			if(m_Weapon == WEAPON_SHOTGUN)
+			{
+				GameServer()->CreateSound(CurPos, m_SoundImpact);
+				GameServer()->CreateSound(CurPos, SOUND_RIFLE_BOUNCE);
+				GameServer()->CreateExplosion(CurPos, m_Owner, m_Weapon, false);
+			}
+			else
+				GameServer()->CreateExplosion(CurPos, m_Owner, m_Weapon, false);
+		}
 
 		else if(TargetChr)
 			TargetChr->TakeDamage(m_Direction * max(0.001f, m_Force), m_Damage, m_Owner, m_Weapon);
-
+		
+		if(m_Clusters > 0)
+		{
+			int pOwner;	
+			vec2 pSpread;
+			CCharacter *OwnerChar = GameServer()->GetPlayerChar(m_Owner);
+			if(OwnerChar)
+			{
+				pOwner = OwnerChar->GetPlayer()->GetCID();
+			
+				CProjectile * pCluster;
+				for(int i =0; i < m_Clusters; i++)
+				{
+					//float a = GetAngle(PrevPos);
+					float a = float(i*(360.f/float((m_Clusters+1))));
+					pSpread = CurPos;
+					pCluster = new CProjectile(GameWorld(), m_ClusterType,
+						pOwner,
+						PrevPos,
+						vec2(cosf(a), sinf(a))*1.1f,
+						m_ClusterLifeSpan,
+						m_ClusterDamage,
+						m_ClusterExplosive, 
+						m_ClusterForce,
+						m_ClusterSoundImpact, 
+						m_ClusterType);
+			
+					CNetObj_Projectile p;
+					pCluster->FillInfo(&p);
+
+					CMsgPacker Msg(NETMSGTYPE_SV_EXTRAPROJECTILE);
+					Msg.AddInt(1);
+					for(unsigned i = 0; i < sizeof(CNetObj_Projectile)/sizeof(int); i++)
+						Msg.AddInt(((int *)&p)[i]);
+					Server()->SendMsg(&Msg, 0, pOwner);
+				}
+			}
+		}
 		GameServer()->m_World.DestroyEntity(this);
 	}
 }
 
+void CProjectile::TickPaused()
+{
+	++m_StartTick;
+}
+
 void CProjectile::FillInfo(CNetObj_Projectile *pProj)
 {
 	pProj->m_X = (int)m_Pos.x;
@@ -103,3 +165,13 @@ void CProjectile::Snap(int SnappingClien
 	if(pProj)
 		FillInfo(pProj);
 }
+
+vec2 CProjectile::GetVel()
+{
+	return m_Direction;
+}
+
+void CProjectile::SetVel(vec2 Vel)
+{
+	m_Direction = Vel;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/projectile.h alien-rc4/src//game/server/entities/projectile.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/projectile.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/projectile.h	2012-06-14 23:57:39.000000000 +0200
@@ -7,13 +7,18 @@ class CProjectile : public CEntity
 {
 public:
 	CProjectile(CGameWorld *pGameWorld, int Type, int Owner, vec2 Pos, vec2 Dir, int Span,
-		int Damage, bool Explosive, float Force, int SoundImpact, int Weapon);
+		int Damage, bool Explosive, float Force, int SoundImpact, int Weapon, 
+		int Clusters=0, int ClusterType=0, int ClusterLifeSpan=0, int ClusterDamage=0, bool ClusterExplosive=0, float ClusterForce=0, 
+		int ClusterSoundImpact=0);
 
 	vec2 GetPos(float Time);
+	vec2 GetVel();
+	void SetVel(vec2 Vel);
 	void FillInfo(CNetObj_Projectile *pProj);
 
 	virtual void Reset();
 	virtual void Tick();
+	virtual void TickPaused();
 	virtual void Snap(int SnappingClient);
 
 private:
@@ -27,6 +32,14 @@ private:
 	float m_Force;
 	int m_StartTick;
 	bool m_Explosive;
+	
+	int m_Clusters;
+	int m_ClusterType;
+	int m_ClusterLifeSpan;
+	int m_ClusterDamage;
+	int m_ClusterExplosive;
+	int m_ClusterForce;
+	int m_ClusterSoundImpact;
 };
 
 #endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/singularinator.cpp alien-rc4/src//game/server/entities/singularinator.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/singularinator.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/singularinator.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,112 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#include <game/generated/protocol.h>
+#include <game/server/gamecontext.h>
+#include "laser.h"
+#include <engine/shared/config.h>
+#include "singularinator.h"
+#include "singularity.h"
+#include <game/server/gamemodes/mod.h>
+
+CSingularinator::CSingularinator(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner, int LifeSpan)
+: CEntity(pGameWorld, CGameWorld::ENTTYPE_LASER)
+{
+	m_LifeSpan = LifeSpan;
+	m_SparkTTL = Server()->Tick() + 3 * Server()->TickSpeed();
+	m_Pos = Pos;
+	m_Fake = Pos;
+	m_Owner = Owner;
+	m_Energy = StartEnergy;
+	m_Dir = Direction*4;
+	m_EvalTick = 0;
+	GameWorld()->InsertEntity(this);
+	Move();
+}
+
+bool CSingularinator::HitCharacter(vec2 From, vec2 To)
+{
+	vec2 At;
+	CCharacter *pOwnerChar = GameServer()->GetPlayerChar(m_Owner);
+	CCharacter *pHit = GameServer()->m_World.IntersectCharacter(m_Pos, To, 0.f, At, pOwnerChar);
+	if(!pHit)
+		return false;
+	else
+	{
+		new CSingularity(&GameServer()->m_World, m_Pos, g_Config.m_SvSingularityRangeW, g_Config.m_SvSingularityKillRange,m_Owner, m_LifeSpan);
+		GameServer()->m_World.DestroyEntity(this);
+		return true;
+	}
+}
+
+void CSingularinator::Move()
+{
+	if(Server()->Tick() - m_SparkTTL > 0)
+	{
+		new CSingularity(&GameServer()->m_World, m_Pos, g_Config.m_SvSingularityRangeW, g_Config.m_SvSingularityKillRange,m_Owner, m_LifeSpan);
+		GameServer()->m_World.DestroyEntity(this);
+		return;
+	}
+
+	vec2 To = m_Pos + m_Dir;
+	m_Dir = m_Dir * 1.05;
+
+	if(GameServer()->Collision()->IntersectLine(m_Pos, To, 0x0, &To))
+	{
+		if(!HitCharacter(m_Pos, To))
+		{
+			m_From = m_Pos;
+			m_Pos = To;
+
+			new CSingularity(&GameServer()->m_World, m_Pos, g_Config.m_SvSingularityRangeW, g_Config.m_SvSingularityKillRange,m_Owner, m_LifeSpan);
+			GameServer()->m_World.DestroyEntity(this);
+			GameServer()->CreateSound(m_Pos, SOUND_RIFLE_BOUNCE);
+			return;
+		}
+	}
+	else
+	{
+		if(!HitCharacter(m_Pos, To))
+		{
+			m_From = m_Pos;
+			m_Pos = To;
+		}
+	}
+}
+
+void CSingularinator::Reset()
+{
+	GameServer()->m_World.DestroyEntity(this);
+}
+
+void CSingularinator::Tick()
+{
+	Move();
+	m_EvalTick = Server()->Tick() - (5 + Server()->Tick()%5);
+	float a = float(Server()->Tick()%900)/2.5f;
+	m_Fake = m_Pos + vec2(cosf(a), sinf(a))*(80.f-Server()->Tick()%70);
+}
+
+void CSingularinator::TickPaused()
+{
+	m_EvalTick = Server()->Tick() - (5 + Server()->Tick()%5);
+	if(Server()->Tick() % 10 == 1)
+	{
+		float a = float(Server()->Tick()%900)/2.5f;
+		m_Fake = m_Pos + vec2(cosf(a), sinf(a))*(80.f-Server()->Tick()%70);
+	}
+}
+
+void CSingularinator::Snap(int SnappingClient)
+{
+	if(NetworkClipped(SnappingClient))
+		return;
+
+	CNetObj_Laser *pObj = static_cast<CNetObj_Laser *>(Server()->SnapNewItem(NETOBJTYPE_LASER, m_ID, sizeof(CNetObj_Laser)));
+	if(!pObj)
+		return;
+
+	pObj->m_X = (int)m_Pos.x;
+	pObj->m_Y = (int)m_Pos.y;
+	pObj->m_FromX = (int)m_Fake.x;
+	pObj->m_FromY = (int)m_Fake.y;
+	pObj->m_StartTick = m_EvalTick;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/singularinator.h alien-rc4/src//game/server/entities/singularinator.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/singularinator.h	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/singularinator.h	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,33 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#ifndef GAME_SERVER_ENTITIES_SINGULARINATOR_H
+#define GAME_SERVER_ENTITIES_SINGULARINATOR_H
+
+#include <game/server/entity.h>
+
+class CSingularinator : public CEntity
+{
+public:
+	CSingularinator(CGameWorld *pGameWorld, vec2 Pos, vec2 Direction, float StartEnergy, int Owner, int LifeSpan);
+
+	virtual void Reset();
+	virtual void Tick();
+	virtual void TickPaused();
+	virtual void Snap(int SnappingClient);
+	static const char * m_SubDescription[];
+
+protected:
+	bool HitCharacter(vec2 From, vec2 To);
+	void Move();
+
+private:
+	vec2 m_From;
+	vec2 m_Fake;
+	vec2 m_Dir;
+	float m_Energy;
+	int m_EvalTick;
+	int m_Owner;
+	int m_SparkTTL;
+	int m_LifeSpan;
+};
+
+#endif
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/singularity.cpp alien-rc4/src//game/server/entities/singularity.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/singularity.cpp	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/singularity.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,111 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#include <game/generated/protocol.h>
+#include <game/server/gamecontext.h>
+#include "laser.h"
+#include "singularity.h"
+#include "projectile.h"
+#include <game/server/gamemodes/mod.h>
+
+CSingularity::CSingularity(CGameWorld *pGameWorld, vec2 Pos, float Range, float KillRange, int Owner, int LifeSpan)
+: CEntity(pGameWorld, CGameWorld::ENTTYPE_LASER)
+{
+	m_Owner = Owner;
+	if(LifeSpan)
+		m_Temporary = 1;
+
+	m_LifeSpan = LifeSpan;
+	m_Range = Range;
+	m_KillRange = KillRange;
+	m_Pos = Pos;
+	m_From = Pos;
+	m_EvalTick = 0;
+	GameWorld()->InsertEntity(this);
+}
+
+void CSingularity::Suck()
+{
+	float Len;
+	
+	CCharacter *p = (CCharacter *)GameServer()->m_World.FindFirst(CGameWorld::ENTTYPE_CHARACTER);
+	for(; p; p = (CCharacter *)p->TypeNext())
+	{
+		if(!p || !p->IsAlive())
+			continue;	
+		
+		Len = distance(m_Pos, p->m_Pos);
+		if(Len < m_KillRange)
+		{
+			if(m_Owner > -1)
+				p->Die(m_Owner,WEAPON_RIFLE);
+			else
+				p->Die(p->GetPlayer()->GetCID(),WEAPON_WORLD);
+		}
+		else if(Len < m_Range)
+			p->SetVel(p->GetVel() + (normalize(m_Pos - p->m_Pos) * exp((m_Range - Len)/(m_Range/2.5f))));
+	}
+
+	// save CPU for projectiles
+	if(m_SkipTick)
+		return;
+	
+	CProjectile *s = (CProjectile *)GameServer()->m_World.FindFirst(CGameWorld::ENTTYPE_PROJECTILE);
+	for(; s; s = (CProjectile *)s->TypeNext())
+	{
+		if(!s)
+			continue;
+		
+		Len = distance(m_Pos, s->m_Pos);
+		if(Len < m_Range*1.5)
+			s->SetVel(s->GetVel() + ((normalize(m_Pos - s->m_Pos) * exp((m_Range*1.5 - Len)/(m_Range*0.6f)))*0.04f));
+	}
+}
+
+void CSingularity::Reset()
+{
+	if(m_Temporary)
+		GameServer()->m_World.DestroyEntity(this);
+	else
+		return;
+}
+
+void CSingularity::Tick()
+{
+	m_EvalTick = Server()->Tick() - (5 + Server()->Tick()%5);
+	m_SkipTick = 1 - m_SkipTick;
+
+	float a = float(Server()->Tick()%900)/2.5f;
+	m_From = m_Pos + vec2(cosf(a), sinf(a))*(300.f-Server()->Tick()%270);
+
+	if(m_Temporary && Server()->Tick() - m_LifeSpan > 0 )
+		GameServer()->m_World.DestroyEntity(this);
+	else
+		Suck();
+}
+
+void CSingularity::TickPaused()
+{
+        m_EvalTick = Server()->Tick() - (5 + Server()->Tick()%5);
+	if(Server()->Tick() % 10 == 1)
+	{
+        	float a = float(Server()->Tick()%900)/2.5f;
+        	m_From = m_Pos + vec2(cosf(a), sinf(a))*(300.f-Server()->Tick()%270);
+	}
+}
+
+void CSingularity::Snap(int SnappingClient)
+{
+        if(NetworkClipped(SnappingClient))
+		return;
+	
+        CNetObj_Laser *pObj; 
+	pObj = static_cast<CNetObj_Laser *>(Server()->SnapNewItem(NETOBJTYPE_LASER, m_ID, sizeof(CNetObj_Laser)));
+        if(!pObj)
+                return;
+
+        pObj->m_X = (int)m_Pos.x;
+        pObj->m_Y = (int)m_Pos.y;
+        pObj->m_FromX = (int)m_From.x;
+        pObj->m_FromY = (int)m_From.y;
+        pObj->m_StartTick = m_EvalTick;
+	return;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/singularity.h alien-rc4/src//game/server/entities/singularity.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/singularity.h	1970-01-01 01:00:00.000000000 +0100
+++ alien-rc4/src//game/server/entities/singularity.h	2012-06-14 23:57:39.000000000 +0200
@@ -0,0 +1,33 @@
+/* (c) Martin Grasberger - See alien-license.txt and licence.txt in the root of the distribution for more information. */
+#ifndef GAME_SERVER_ENTITIES_SINGULARITY_H
+#define GAME_SERVER_ENTITIES_SINGULARITY_H
+
+#include <game/server/entity.h>
+
+
+class CSingularity : public CEntity
+{
+public:
+	CSingularity(CGameWorld *pGameWorld, vec2 Pos, float Range, float KillRange, int Owner, int LifeSpan);
+
+	virtual void Reset();
+	virtual void Tick();
+	virtual void TickPaused();
+	virtual void Snap(int SnappingClient);
+	static const char * m_SubDescription[];
+
+protected:
+	void Suck();
+
+private:
+	vec2 m_From;
+	int m_Owner;
+	bool m_Temporary;
+	int m_LifeSpan;
+	float m_Range;
+	float m_KillRange;
+	bool m_SkipTick;
+	int m_EvalTick;
+};
+
+#endif
